"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.storeActivities = storeActivities;
exports.updateActivity = updateActivity;
exports.deleteActivity = deleteActivity;
exports.DELETE_ACTIVITY = exports.UPDATE_ACTIVITY = exports.STORE_ACTIVITIES = void 0;

var _assign = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/assign"));

var _helpers = require("./helpers");

var STORE_ACTIVITIES = 'activities/STORE_ACTIVITIES';
exports.STORE_ACTIVITIES = STORE_ACTIVITIES;
var UPDATE_ACTIVITY = 'activities/UPDATE_ACTIVITY';
exports.UPDATE_ACTIVITY = UPDATE_ACTIVITY;
var DELETE_ACTIVITY = 'activities/DELETE_ACTIVITY';
exports.DELETE_ACTIVITY = DELETE_ACTIVITY;

function storeActivities(activities) {
  return {
    type: STORE_ACTIVITIES,
    payload: {
      activities: (0, _helpers.constructActivities)(activities)
    }
  };
}

function updateActivity(activity) {
  return {
    type: UPDATE_ACTIVITY,
    payload: {
      activity: (0, _helpers.constructActivity)(activity)
    }
  };
}
/**
 * "Delete" an activity == tombstoning the activity
 *
 * @export
 * @param {Object} activity
 * @returns {Object} redux action
 */


function deleteActivity(activity) {
  var tombstoneActivity = (0, _assign.default)({}, activity, {
    verb: 'tombstone'
  });
  return {
    type: DELETE_ACTIVITY,
    payload: {
      activitiy: (0, _helpers.constructActivity)(tombstoneActivity)
    }
  };
}