"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = reducer;
exports.initialState = exports.Activity = void 0;

var _immutable = require("immutable");

var _actions = require("./actions");

var Activity = (0, _immutable.Record)({
  id: null,
  actor: null,
  type: '',
  object: {}
});
exports.Activity = Activity;
var initialState = (0, _immutable.Map)({
  byId: (0, _immutable.Map)()
});
exports.initialState = initialState;

function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case _actions.STORE_ACTIVITIES:
      {
        var activities = {};
        action.payload.activities.forEach(function (a) {
          activities[a.id] = new Activity(a);
        });
        return state.mergeIn(['byId'], activities);
      }

    case _actions.UPDATE_ACTIVITY:
      {
        var activity = action.payload.activity;
        return state.mergeDeepIn(['byId', activity.id], activity);
      }

    case _actions.DELETE_ACTIVITY:
      {
        var _activity = action.payload.activity;
        return state.setIn(['byId', _activity.id], _activity);
      }

    default:
      return state;
  }
}